#ifndef EMBEDDINGENGINE_H
#define EMBEDDINGENGINE_H

#include<vector>
#include<string>
#include "aiengineerror.h"


namespace ai_engine{
namespace tm {
namespace embedding{


class AbstractEmbeddingEngine{
public:
    virtual ~AbstractEmbeddingEngine();
    virtual std::string aiengineName() = 0;
    virtual bool isCloud() = 0;

    enum class InputDataType {text , Base64Image};

    enum class EmbeddingModel { TextModel = 0, ImageModel};


    virtual std::vector<float> embeddingText(EmbeddingModel model,
                                        const std::string& input,
                                        ai_engine::tm::EngineError &error);
    virtual std::vector<float> embeddingImage(EmbeddingModel model,
                                        const std::string& input,
                                        InputDataType dataType,
                                        ai_engine::tm::EngineError &error);

};



} // namespace embedding
} // namespace tm
} // namespace ai_engine


#endif // EMBEDDINGENGINE_H

